---  i386/i386/pmap.c.orig
+++  i386/i386/pmap.c
@@ -3082,27 +3518,57 @@
 					("pmap_remove_pages: bad tpte %#jx",
 					(uintmax_t)tpte));
 
-				pmap->pm_stats.resident_count--;
-
 				pte_clear(pte);
 
 				/*
 				 * Update the vm_page_t clean/reference bits.
 				 */
-				if (tpte & PG_M)
-					vm_page_dirty(m);
+				if (tpte & PG_M) {
+					KASSERT((tpte & PG_RW) != 0,
+	("pmap_remove_pages: modified page not writable: va: %#x, pte: %#jx",
+					    pv->pv_va, (uintmax_t)tpte));
+					if ((tpte & PG_PS) != 0) {
+						for (mt = m; mt < &m[NBPDR / PAGE_SIZE]; mt++)
+							vm_page_dirty(mt);
+					} else
+						vm_page_dirty(m);
+				}
 
 				/* Mark free */
 				PV_STAT(pv_entry_frees++);
 				PV_STAT(pv_entry_spare++);
 				pv_entry_count--;
 				pc->pc_map[field] |= bitmask;
-				m->md.pv_list_count--;
-				TAILQ_REMOVE(&m->md.pv_list, pv, pv_list);
-				if (TAILQ_EMPTY(&m->md.pv_list))
-					vm_page_flag_clear(m, PG_WRITEABLE);
-
-				pmap_unuse_pt(pmap, pv->pv_va, &free);
+				if ((tpte & PG_PS) != 0) {
+					pmap->pm_stats.resident_count -= NBPDR / PAGE_SIZE;
+					pvh = pa_to_pvh(tpte & PG_FRAME);
+					pvh->pv_list_count--;
+					TAILQ_REMOVE(&pvh->pv_list, pv, pv_list);
+					if (TAILQ_EMPTY(&pvh->pv_list)) {
+						for (mt = m; mt < &m[NBPDR / PAGE_SIZE]; mt++)
+							if (TAILQ_EMPTY(&mt->md.pv_list))
+								vm_page_flag_clear(mt, PG_WRITEABLE);
+					}
+					mpte = pmap_lookup_pt_page(pmap, pv->pv_va);
+					if (mpte != NULL) {
+						pmap_remove_pt_page(pmap, mpte);
+						KASSERT(mpte->wire_count == NPTEPG,
+						    ("pmap_remove_pages: pte page wire count error"));
+						mpte->wire_count = 0;
+						vm_page_free(mpte);
+						atomic_subtract_int(&cnt.v_wire_count, 1);
+					}
+				} else {
+					pmap->pm_stats.resident_count--;
+					m->md.pv_list_count--;
+					TAILQ_REMOVE(&m->md.pv_list, pv, pv_list);
+					if (TAILQ_EMPTY(&m->md.pv_list)) {
+						pvh = pa_to_pvh(VM_PAGE_TO_PHYS(m));
+						if (TAILQ_EMPTY(&pvh->pv_list))
+							vm_page_flag_clear(m, PG_WRITEABLE);
+					}
+					pmap_unuse_pt(pmap, pv->pv_va);
+				}
 			}
 		}
 		if (allfree) {
@@ -3118,9 +3584,8 @@
 		}
 	}
 	sched_unpin();
+	vm_page_unlock_queues();
 	pmap_invalidate_all(pmap);
-	pmap_free_zero_pages(free);
-	vm_page_unlock_queues();
 	PMAP_UNLOCK(pmap);
 }
 
@@ -3133,18 +3598,31 @@
 boolean_t
 pmap_is_modified(vm_page_t m)
 {
+
+	if (m->flags & PG_FICTITIOUS)
+		return (FALSE);
+	if (pmap_is_modified_pvh(&m->md))
+		return (TRUE);
+	return (pmap_is_modified_pvh(pa_to_pvh(VM_PAGE_TO_PHYS(m))));
+}
+
+/*
+ * Returns TRUE if any of the given mappings were used to modify
+ * physical memory.  Otherwise, returns FALSE.  Both page and 2mpage
+ * mappings are supported.
+ */
+static boolean_t
+pmap_is_modified_pvh(struct md_page *pvh)
+{
 	pv_entry_t pv;
 	pt_entry_t *pte;
 	pmap_t pmap;
 	boolean_t rv;
 
+	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
 	rv = FALSE;
-	if (m->flags & PG_FICTITIOUS)
-		return (rv);
-
 	sched_pin();
-	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
-	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+	TAILQ_FOREACH(pv, &pvh->pv_list, pv_list) {
 		pmap = PV_PMAP(pv);
 		PMAP_LOCK(pmap);
 		pte = pmap_pte_quick(pmap, pv->pv_va);
@@ -3166,12 +3644,14 @@
 boolean_t
 pmap_is_prefaultable(pmap_t pmap, vm_offset_t addr)
 {
+	pd_entry_t *pde;
 	pt_entry_t *pte;
 	boolean_t rv;
 
 	rv = FALSE;
 	PMAP_LOCK(pmap);
-	if (*pmap_pde(pmap, addr)) {
+	pde = pmap_pde(pmap, addr);
+	if (*pde != 0 && (*pde & PG_PS) == 0) {
 		pte = vtopte(addr);
 		rv = *pte == 0;
 	}
@@ -3185,18 +3665,34 @@
 void
 pmap_remove_write(vm_page_t m)
 {
-	pv_entry_t pv;
+	struct md_page *pvh;
+	pv_entry_t next_pv, pv;
 	pmap_t pmap;
+	pd_entry_t *pde;
 	pt_entry_t oldpte, *pte;
+	vm_offset_t va;
 
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
 	if ((m->flags & PG_FICTITIOUS) != 0 ||
 	    (m->flags & PG_WRITEABLE) == 0)
 		return;
 	sched_pin();
+	pvh = pa_to_pvh(VM_PAGE_TO_PHYS(m));
+	TAILQ_FOREACH_SAFE(pv, &pvh->pv_list, pv_list, next_pv) {
+		va = pv->pv_va;
+		pmap = PV_PMAP(pv);
+		PMAP_LOCK(pmap);
+		pde = pmap_pde(pmap, va);
+		if ((*pde & PG_RW) != 0 && !pmap_demote_pde(pmap, pde, va))
+			pmap_invalidate_page(pmap, va);
+		PMAP_UNLOCK(pmap);
+	}
 	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
 		pmap = PV_PMAP(pv);
 		PMAP_LOCK(pmap);
+		pde = pmap_pde(pmap, pv->pv_va);
+		KASSERT((*pde & PG_PS) == 0, ("pmap_clear_write: found"
+		    " a 4mpage in page %p's pv list", m));
 		pte = pmap_pte_quick(pmap, pv->pv_va);
 retry:
 		oldpte = *pte;
@@ -3234,15 +3730,47 @@
 int
 pmap_ts_referenced(vm_page_t m)
 {
+	struct md_page *pvh;
 	pv_entry_t pv, pvf, pvn;
 	pmap_t pmap;
+	pd_entry_t oldpde, *pde;
 	pt_entry_t *pte;
+	vm_offset_t va;
 	int rtval = 0;
 
 	if (m->flags & PG_FICTITIOUS)
 		return (rtval);
 	sched_pin();
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
+	pvh = pa_to_pvh(VM_PAGE_TO_PHYS(m));
+	TAILQ_FOREACH_SAFE(pv, &pvh->pv_list, pv_list, pvn) {
+		va = pv->pv_va;
+		pmap = PV_PMAP(pv);
+		PMAP_LOCK(pmap);
+		pde = pmap_pde(pmap, va);
+		oldpde = *pde;
+		if ((oldpde & PG_A) != 0) {
+			if (pmap_demote_pde(pmap, pde, va)) {
+				if ((oldpde & PG_W) == 0) {
+					/*
+					 * Remove the mapping to a single page
+					 * so that a subsequent access may
+					 * repromote.
+					 */
+					va += VM_PAGE_TO_PHYS(m) - (oldpde &
+					    PG_FRAME);
+					pmap_remove_page(pmap, va);
+					rtval++;
+					if (rtval > 4) {
+						PMAP_UNLOCK(pmap);
+						return (rtval);
+					}
+				}
+			} else
+				pmap_invalidate_page(pmap, va);
+		}
+		PMAP_UNLOCK(pmap);
+	}
 	if ((pv = TAILQ_FIRST(&m->md.pv_list)) != NULL) {
 		pvf = pv;
 		do {
@@ -3251,6 +3779,9 @@
 			TAILQ_INSERT_TAIL(&m->md.pv_list, pv, pv_list);
 			pmap = PV_PMAP(pv);
 			PMAP_LOCK(pmap);
+			pde = pmap_pde(pmap, pv->pv_va);
+			KASSERT((*pde & PG_PS) == 0, ("pmap_ts_referenced:"
+			    " found a 4mpage in page %p's pv list", m));
 			pte = pmap_pte_quick(pmap, pv->pv_va);
 			if ((*pte & PG_A) != 0) {
 				atomic_clear_int((u_int *)pte, PG_A);
@@ -3272,17 +3803,63 @@
 void
 pmap_clear_modify(vm_page_t m)
 {
-	pv_entry_t pv;
+	struct md_page *pvh;
+	pv_entry_t next_pv, pv;
 	pmap_t pmap;
-	pt_entry_t *pte;
+	pd_entry_t oldpde, *pde;
+	pt_entry_t oldpte, *pte;
+	vm_offset_t va;
 
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
 	if ((m->flags & PG_FICTITIOUS) != 0)
 		return;
 	sched_pin();
+	pvh = pa_to_pvh(VM_PAGE_TO_PHYS(m));
+	TAILQ_FOREACH_SAFE(pv, &pvh->pv_list, pv_list, next_pv) {
+		va = pv->pv_va;
+		pmap = PV_PMAP(pv);
+		PMAP_LOCK(pmap);
+		pde = pmap_pde(pmap, va);
+		oldpde = *pde;
+		if ((oldpde & PG_RW) != 0) {
+			if (pmap_demote_pde(pmap, pde, va)) {
+				if ((oldpde & PG_W) == 0) {
+					/*
+					 * Write protect the mapping to a
+					 * single page so that a subsequent
+					 * write access may repromote.
+					 */
+					va += VM_PAGE_TO_PHYS(m) - (oldpde &
+					    PG_FRAME);
+					pte = pmap_pte_quick(pmap, va);
+					oldpte = *pte;
+					if ((oldpte & PG_V) != 0) {
+						/*
+						 * Regardless of whether a pte is 32 or 64 bits
+						 * in size, PG_RW and PG_M are among the least
+						 * significant 32 bits.
+						 */
+						while (!atomic_cmpset_int((u_int *)pte,
+						    oldpte,
+						    oldpte & ~(PG_M | PG_RW)))
+							oldpte = *pte;
+						vm_page_dirty(m);
+						pmap_invalidate_page(pmap, va);
+					}
+				}
+			} else
+				pmap_invalidate_page(pmap, va);
+		} else
+			KASSERT((oldpde & PG_M) == 0,
+			    ("pmap_clear_modify: modified page not writable"));
+		PMAP_UNLOCK(pmap);
+	}
 	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
 		pmap = PV_PMAP(pv);
 		PMAP_LOCK(pmap);
+		pde = pmap_pde(pmap, pv->pv_va);
+		KASSERT((*pde & PG_PS) == 0, ("pmap_clear_modify: found"
+		    " a 4mpage in page %p's pv list", m));
 		pte = pmap_pte_quick(pmap, pv->pv_va);
 		if ((*pte & PG_M) != 0) {
 			/*
@@ -3306,17 +3883,43 @@
 void
 pmap_clear_reference(vm_page_t m)
 {
-	pv_entry_t pv;
+	struct md_page *pvh;
+	pv_entry_t next_pv, pv;
 	pmap_t pmap;
+	pd_entry_t oldpde, *pde;
 	pt_entry_t *pte;
+	vm_offset_t va;
 
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
 	if ((m->flags & PG_FICTITIOUS) != 0)
 		return;
 	sched_pin();
+	pvh = pa_to_pvh(VM_PAGE_TO_PHYS(m));
+	TAILQ_FOREACH_SAFE(pv, &pvh->pv_list, pv_list, next_pv) {
+		va = pv->pv_va;
+		pmap = PV_PMAP(pv);
+		PMAP_LOCK(pmap);
+		pde = pmap_pde(pmap, va);
+		oldpde = *pde;
+		if ((oldpde & PG_A) != 0) {
+			if (pmap_demote_pde(pmap, pde, va)) {
+				/*
+				 * Remove the mapping to a single page so
+				 * that a subsequent access may repromote.
+				 */
+				va += VM_PAGE_TO_PHYS(m) - (oldpde & PG_FRAME);
+				pmap_remove_page(pmap, va);
+			} else
+				pmap_invalidate_page(pmap, va);
+		}
+		PMAP_UNLOCK(pmap);
+	}
 	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
 		pmap = PV_PMAP(pv);
 		PMAP_LOCK(pmap);
+		pde = pmap_pde(pmap, pv->pv_va);
+		KASSERT((*pde & PG_PS) == 0, ("pmap_clear_reference: found"
+		    " a 4mpage in page %p's pv list", m));
 		pte = pmap_pte_quick(pmap, pv->pv_va);
 		if ((*pte & PG_A) != 0) {
 			/*
@@ -3466,25 +4069,35 @@
 int
 pmap_mincore(pmap_t pmap, vm_offset_t addr)
 {
+	pd_entry_t *pdep;
 	pt_entry_t *ptep, pte;
+	vm_paddr_t pa;
 	vm_page_t m;
 	int val = 0;
 	
 	PMAP_LOCK(pmap);
-	ptep = pmap_pte(pmap, addr);
-	pte = (ptep != NULL) ? *ptep : 0;
-	pmap_pte_release(ptep);
+	pdep = pmap_pde(pmap, addr);
+	if (*pdep != 0) {
+		if (*pdep & PG_PS) {
+			pte = *pdep;
+			pa = (*pdep & ~PDRMASK) | (addr & PDRMASK);
+		} else {
+			ptep = pmap_pte(pmap, addr);
+			pte = *ptep;
+			pmap_pte_release(ptep);
+			pa = pte & PG_FRAME;
+		}
+	} else {
+		pte = 0;
+		pa = 0;
+	}
 	PMAP_UNLOCK(pmap);
 
 	if (pte != 0) {
-		vm_paddr_t pa;
-
 		val = MINCORE_INCORE;
 		if ((pte & PG_MANAGED) == 0)
 			return val;
 
-		pa = pte & PG_FRAME;
-
 		m = PHYS_TO_VM_PAGE(pa);
 
 		/*
@@ -3564,6 +4177,301 @@
 	return addr;
 }
 
+#define COMPATIBLE_PTE_MASK (PG_MANAGED | PG_W | PG_G | PG_PTE_PAT | PG_M | PG_A | PG_NC_PCD | PG_NC_PWT | PG_U | PG_RW | PG_V)
+#define COMPATIBLE_PTE(a,b) (((a) & COMPATIBLE_PTE_MASK) == ((b) & COMPATIBLE_PTE_MASK))
+
+SYSCTL_NODE(_vm_pmap, OID_AUTO, pde, CTLFLAG_RD, 0, "");
+
+static u_long pmap_pde_promotions;
+SYSCTL_ULONG(_vm_pmap_pde, OID_AUTO, promotions, CTLFLAG_RD,
+    &pmap_pde_promotions, 0, "pde promotions");
+
+/*
+ * Managed (PG_MANAGED) mappings within the kernel address space are
+ * not promoted.  The reason is that kernel PDEs are replicated in
+ * each pmap but pmap_clear_ptes() and pmap_ts_referenced() only read
+ * the PDE from the kernel pmap.
+ */
+static void
+pmap_promote_pde(pmap_t pmap, pd_entry_t *pde, vm_offset_t va)
+{
+	pd_entry_t newpde;
+	pmap_t allpmaps_entry;
+	pt_entry_t *firstpte, oldpte, *pte;
+	vm_paddr_t pa;
+	vm_page_t mpte;
+
+	PMAP_LOCK_ASSERT(pmap, MA_OWNED);
+	firstpte = vtopte(trunc_4mpage(va));
+	KASSERT((*firstpte & PG_V) != 0,
+	    ("pmap_promote_pde: firstpte is missing PG_V"));
+	if ((*firstpte & PG_A) == 0)
+		return;
+	if ((*firstpte & PG_MANAGED) != 0 && pmap == kernel_pmap)
+		return;
+	pa = *firstpte & PG_FRAME & ~PDRMASK;
+	newpde = *firstpte;
+	if ((newpde & (PG_M | PG_RW)) == PG_RW)
+		newpde &= ~PG_RW;
+
+	/* 
+	 * Check all the ptes before promotion
+	 */
+	for (pte = firstpte; pte < firstpte + NPTEPG; pte++) {
+retry:
+		oldpte = *pte;
+		if ((oldpte & PG_FRAME) != pa) {
+			CTR2(KTR_PMAP, "pmap_promote_pde: failure for va %#x"
+			    " in pmap %p", va, pmap);
+			return;
+		}
+		if ((oldpte & (PG_M | PG_RW)) == PG_RW) {
+			/*
+			 * When PG_M is already clear, PG_RW can be cleared
+			 * without a TLB invalidation.
+			 */
+			if (!atomic_cmpset_int((u_int *)pte, oldpte,
+			    oldpte & ~PG_RW))
+				goto retry;
+			oldpte = *pte;
+		}
+		if (!COMPATIBLE_PTE(oldpte, newpde)) {
+			CTR2(KTR_PMAP, "pmap_promote_pde: failure for va %#x"
+			    " in pmap %p", va, pmap);
+			return;
+		}
+		pa += PAGE_SIZE;
+	}
+
+	/*
+	 * Save the page table page in its current state until the PDE
+	 * mapping the superpage is demoted by pmap_demote_pde() or
+	 * destroyed by pmap_remove_pde(). 
+	 */
+	mpte = PHYS_TO_VM_PAGE(*pde & PG_FRAME);
+	KASSERT(mpte >= vm_page_array &&
+	    mpte < &vm_page_array[vm_page_array_size],
+	    ("pmap_promote_pde: page table page is out of range"));
+	KASSERT(mpte->pindex == va >> PDRSHIFT,
+	    ("pmap_promote_pde: page table page's pindex is wrong"));
+	pmap_insert_pt_page(pmap, mpte);
+
+	/*
+	 * Promote the pv entries.
+	 */
+	if ((newpde & PG_MANAGED) != 0)
+		pmap_pv_promote_pde(pmap, va, newpde & PG_FRAME);
+
+	/*
+	 * Propagate the PAT index to its proper position.
+	 */
+	if ((newpde & PG_PTE_PAT) != 0)
+		newpde ^= PG_PDE_PAT | PG_PTE_PAT;
+
+	/*
+	 * Map the superpage.
+	 */
+	if (pmap == kernel_pmap) {
+		mtx_lock_spin(&allpmaps_lock);
+		LIST_FOREACH(allpmaps_entry, &allpmaps, pm_list) {
+			pde = pmap_pde(allpmaps_entry, va);
+			pde_store(pde, PG_PS | newpde);
+		}
+		mtx_unlock_spin(&allpmaps_lock);
+	} else
+		pde_store(pde, PG_PS | newpde);
+
+	pmap_pde_promotions++;
+	CTR2(KTR_PMAP, "pmap_promote_pde: success for va %#x"
+	    " in pmap %p", va, pmap);
+}
+
+static u_long pmap_pde_demotions;
+SYSCTL_ULONG(_vm_pmap_pde, OID_AUTO, demotions, CTLFLAG_RD,
+    &pmap_pde_demotions, 0, "pde demotions");
+
+static boolean_t
+pmap_demote_pde(pmap_t pmap, pd_entry_t *pde, vm_offset_t va)
+{
+	pd_entry_t newpde, oldpde;
+	pmap_t allpmaps_entry;
+	pt_entry_t *firstpte, newpte, *pte;
+	vm_paddr_t mptepa;
+	vm_page_t mpte;
+
+	PMAP_LOCK_ASSERT(pmap, MA_OWNED);
+	mpte = pmap_lookup_pt_page(pmap, va);
+	if (mpte != NULL)
+		pmap_remove_pt_page(pmap, mpte);
+	else {
+		KASSERT((*pde & PG_W) == 0,
+		    ("pmap_demote_pde: page table page for a wired mapping"
+		    " is missing"));
+		pmap_remove_pde(pmap, pde, trunc_4mpage(va));
+		CTR2(KTR_PMAP, "pmap_demote_pde: failure for va %#x"
+		    " in pmap %p", va, pmap);
+		return (FALSE);
+	}
+	mptepa = VM_PAGE_TO_PHYS(mpte);
+
+	/*
+	 * Temporarily map the page table page (mpte) into the kernel's
+	 * address space at either PADDR1 or PADDR2.
+	 */
+	if (curthread->td_pinned > 0 && mtx_owned(&vm_page_queue_mtx)) {
+		if ((*PMAP1 & PG_FRAME) != mptepa) {
+			*PMAP1 = mptepa | PG_RW | PG_V | PG_A | PG_M;
+#ifdef SMP
+			PMAP1cpu = PCPU_GET(cpuid);
+#endif
+			invlcaddr(PADDR1);
+			PMAP1changed++;
+		} else
+#ifdef SMP
+		if (PMAP1cpu != PCPU_GET(cpuid)) {
+			PMAP1cpu = PCPU_GET(cpuid);
+			invlcaddr(PADDR1);
+			PMAP1changedcpu++;
+		} else
+#endif
+			PMAP1unchanged++;
+		firstpte = PADDR1;
+	} else {
+		mtx_lock(&PMAP2mutex);
+		if ((*PMAP2 & PG_FRAME) != mptepa) {
+			*PMAP2 = mptepa | PG_RW | PG_V | PG_A | PG_M;
+			pmap_invalidate_page(kernel_pmap, (vm_offset_t)PADDR2);
+		}
+		firstpte = PADDR2;
+	}
+	oldpde = *pde;
+	newpde = mptepa | PG_M | PG_A | (oldpde & PG_U) | PG_RW | PG_V;
+	KASSERT((oldpde & (PG_A | PG_V)) == (PG_A | PG_V),
+	    ("pmap_demote_pde: oldpde is missing PG_A and/or PG_V"));
+	KASSERT((oldpde & (PG_M | PG_RW)) != PG_RW,
+	    ("pmap_demote_pde: oldpde is missing PG_M"));
+	KASSERT((oldpde & PG_PS) != 0,
+	    ("pmap_demote_pde: oldpde is missing PG_PS"));
+	newpte = oldpde & ~PG_PS;
+	if ((newpte & PG_PDE_PAT) != 0)
+		newpte ^= PG_PDE_PAT | PG_PTE_PAT;
+
+	/*
+	 * If the mapping has changed attributes, update the page table
+	 * entries.
+	 */ 
+	KASSERT((*firstpte & PG_FRAME) == (newpte & PG_FRAME),
+	    ("pmap_demote_pde: firstpte and newpte map different physical"
+	    " addresses"));
+	if (!COMPATIBLE_PTE(*firstpte, newpte))
+		for (pte = firstpte; pte < firstpte + NPTEPG; pte++) {
+			*pte = newpte;	
+			newpte += PAGE_SIZE;
+		}
+	
+	/*
+	 * Demote the mapping.  This pmap is locked.  The old PDE has
+	 * PG_A set.  If the old PDE has PG_RW set, it also has PG_M
+	 * set.  Thus, there is no danger of a race with another
+	 * processor changing the setting of PG_A and/or PG_M between
+	 * the read above and the store below. 
+	 */
+	if (pmap == kernel_pmap) {
+		/*
+		 * A harmless race exists between this loop and the bcopy()
+		 * in pmap_pinit() that initializes the kernel segment of
+		 * the new page table.  Specifically, that bcopy() may copy
+		 * the new PDE from the PTD, which is first in allpmaps, to
+		 * the new page table before this loop updates that new
+		 * page table.
+		 */
+		mtx_lock_spin(&allpmaps_lock);
+		LIST_FOREACH(allpmaps_entry, &allpmaps, pm_list) {
+			pde = pmap_pde(allpmaps_entry, va);
+			KASSERT(*pde == newpde || COMPATIBLE_PTE(*pde,
+			    oldpde),
+			    ("pmap_demote_pde: pde was %#jx, expected %#jx",
+			    (uintmax_t)*pde, (uintmax_t)oldpde));
+			pde_store(pde, newpde);
+		}
+		mtx_unlock_spin(&allpmaps_lock);
+	} else
+		pde_store(pde, newpde);	
+	if (firstpte == PADDR2)
+		mtx_unlock(&PMAP2mutex);
+
+	/*
+	 * Invalidate the recursive mapping of the page table page.
+	 */
+	pmap_invalidate_page(pmap, (vm_offset_t)vtopte(va));
+
+	/*
+	 * Demote the pv entry.  This depends on the earlier demotion
+	 * of the mapping.  Specifically, the (re)creation of a per-
+	 * page pv entry might trigger the execution of pmap_collect(),
+	 * which might reclaim a newly (re)created per-page pv entry
+	 * and destroy the associated mapping.  In order to destroy
+	 * the mapping, the PDE must have already changed from mapping
+	 * the 2mpage to referencing the page table page.
+	 */
+	if ((oldpde & PG_MANAGED) != 0)
+		pmap_pv_demote_pde(pmap, va, oldpde & PG_FRAME);
+
+	pmap_pde_demotions++;
+	CTR2(KTR_PMAP, "pmap_demote_pde: success for va %#x"
+	    " in pmap %p", va, pmap);
+	return (TRUE);
+}
+
+static u_long pmap_pde_mappings;
+SYSCTL_ULONG(_vm_pmap_pde, OID_AUTO, mappings, CTLFLAG_RD,
+    &pmap_pde_mappings, 0, "pde mappings");
+
+static boolean_t
+pmap_enter_pde(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot)
+{
+	pd_entry_t *pde, newpde;
+
+	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
+	PMAP_LOCK_ASSERT(pmap, MA_OWNED);
+	pde = pmap_pde(pmap, va);
+	if (*pde != 0) {
+		CTR2(KTR_PMAP, "pmap_enter_pde: failure for va %#lx"
+		    " in pmap %p", va, pmap);
+		return (FALSE);
+	}
+	newpde = VM_PAGE_TO_PHYS(m) | PG_PS | PG_V;
+	if ((m->flags & (PG_FICTITIOUS | PG_UNMANAGED)) == 0) {
+		newpde |= PG_MANAGED;
+
+		/*
+		 * Create a PV entry for each of the managed pages.
+		 */
+		if (!pmap_pv_insert_pde(pmap, va, m)) {
+			CTR2(KTR_PMAP, "pmap_enter_pde: failure for va %#lx"
+			    " in pmap %p", va, pmap);
+			return (FALSE);
+		}
+	}
+	if (va < VM_MAXUSER_ADDRESS)
+		newpde |= PG_U;
+
+	/*
+	 * Increment counters.
+	 */
+	pmap->pm_stats.resident_count += NBPDR / PAGE_SIZE;
+
+	/*
+	 * Map the superpage.
+	 */
+	pde_store(pde, newpde);
+
+	pmap_pde_mappings++;
+	CTR2(KTR_PMAP, "pmap_enter_pde: success for va %#lx"
+	    " in pmap %p", va, pmap);
+	return (TRUE);
+}
+
 
 #if defined(PMAP_DEBUG)
 pmap_pid_dump(int pid)
---  i386/include/param.h.orig
+++  i386/include/param.h
@@ -93,6 +93,33 @@
 #define NBPDR		(1<<PDRSHIFT)	/* bytes/page dir */
 #define PDRMASK		(NBPDR-1)
 
+/*
+ * SP_LEVELS is the number of superpage sizes.
+ */
+#ifndef	SP_LEVELS
+#define	SP_LEVELS	1
+#endif
+
+/*
+ * SP_SMALL_SHIFT is LOG2(NBPDR / PAGE_SIZE).
+ */
+#ifdef PAE
+#ifndef	SP_SMALL_SHIFT
+#define	SP_SMALL_SHIFT	9
+#endif
+#else
+#ifndef	SP_SMALL_SHIFT
+#define	SP_SMALL_SHIFT	10
+#endif
+#endif
+
+/*
+ * If there is only one superpage size, then SP_FACTOR_SHIFT is zero.
+ */
+#ifndef	SP_FACTOR_SHIFT
+#define	SP_FACTOR_SHIFT	0
+#endif
+
 #define IOPAGES	2		/* pages of i/o permission bitmap */
 
 #ifndef KSTACK_PAGES
---  i386/include/pmap.h.orig
+++  i386/include/pmap.h
@@ -222,6 +222,9 @@
 
 #ifdef PAE
 
+#define	pde_cmpset(pdep, old, new) \
+				atomic_cmpset_64((pdep), (old), (new))
+
 static __inline pt_entry_t
 pte_load(pt_entry_t *ptep)
 {
@@ -278,6 +281,9 @@
 
 #else /* PAE */
 
+#define	pde_cmpset(pdep, old, new) \
+				atomic_cmpset_int((pdep), (old), (new))
+
 static __inline pt_entry_t
 pte_load(pt_entry_t *ptep)
 {
@@ -340,6 +346,7 @@
 	pdpt_entry_t		*pm_pdpt;	/* KVA of page director pointer
 						   table */
 #endif
+	vm_page_t		pm_root;	/* spare page table pages */
 };
 
 typedef struct pmap	*pmap_t;
@@ -403,7 +410,6 @@
 extern vm_offset_t virtual_avail;
 extern vm_offset_t virtual_end;
 
-#define	pmap_page_is_mapped(m)	(!TAILQ_EMPTY(&(m)->md.pv_list))
 #define	pmap_unmapbios(va, sz)	pmap_unmapdev((va), (sz))
 
 void	pmap_bootstrap(vm_paddr_t);
@@ -416,6 +422,7 @@
 void	*pmap_mapbios(vm_paddr_t, vm_size_t);
 void	*pmap_mapdev(vm_paddr_t, vm_size_t);
 void	*pmap_mapdev_attr(vm_paddr_t, vm_size_t, int);
+boolean_t pmap_page_is_mapped(vm_page_t m);
 void	pmap_unmapdev(vm_offset_t, vm_size_t);
 pt_entry_t *pmap_pte(pmap_t, vm_offset_t) __pure2;
 void	pmap_set_pg(void);
---  i386/include/vmparam.h.orig
+++  i386/include/vmparam.h
@@ -129,6 +129,49 @@
 #endif
 
 /*
+ * Allow for one more than the number of phys_avail[] entries because
+ * the phys_avail[] entry that spans the largest physical address that
+ * is accessible by ISA DMA is split into two physseg entries.
+ */
+#define	VM_PHYSSEG_MAX		17
+
+/*
+ * Create XXX free page pools: XXX
+ */
+#define	VM_NFREEPOOL		1
+#define	VM_FREEPOOL_DEFAULT	0
+#define	VM_FREEPOOL_DIRECT	0
+#define	VM_FREEPOOL_RESERV	0
+
+/*
+ * Create two free page lists: VM_FREELIST_DEFAULT is for physical
+ * pages that are above the largest physical address that is
+ * accessible by ISA DMA and VM_FREELIST_ISADMA is for physical pages
+ * that are below that address.
+ */
+#ifdef PAE
+#define	VM_NFREELIST		3
+#else
+#define	VM_NFREELIST		2
+#endif
+#define	VM_FREELIST_DEFAULT	0
+#define	VM_FREELIST_ISADMA	1
+#ifdef PAE
+#define	VM_FREELIST_HIGHMEM	2
+#endif
+
+/*
+ * VM_HIGHMEM_ADDRESS is the physical address at which HIGHMEM starts.
+ */
+#define	VM_HIGHMEM_ADDRESS	4294967296ULL
+
+#ifdef PAE
+#define	VM_NFREEORDER		10
+#else
+#define	VM_NFREEORDER		11
+#endif
+
+/*
  * Virtual addresses of things.  Derived from the page directory and
  * page table indexes from pmap.h for precision.
  * Because of the page that is both a PD and PT, it looks a little
@@ -177,4 +220,8 @@
 #define	VM_INITIAL_PAGEIN	16
 #endif
 
+#ifndef	VM_IMAGE_BASE
+#define	VM_IMAGE_BASE		0x8048000
+#endif
+
 #endif /* _MACHINE_VMPARAM_H_ */
---  ia64/ia64/pmap.c.orig
+++  ia64/ia64/pmap.c
@@ -50,6 +50,7 @@
 
 #include <sys/param.h>
 #include <sys/kernel.h>
+#include <sys/ktr.h>
 #include <sys/lock.h>
 #include <sys/mman.h>
 #include <sys/mutex.h>
@@ -60,9 +61,11 @@
 
 #include <vm/vm.h>
 #include <vm/vm_page.h>
+#include <vm/vm_phys.h>
 #include <vm/vm_map.h>
 #include <vm/vm_object.h>
 #include <vm/vm_pageout.h>
+#include <vm/vm_reserv.h>
 #include <vm/uma.h>
 
 #include <machine/md_var.h>
@@ -249,27 +252,12 @@
 vm_offset_t
 pmap_steal_memory(vm_size_t size)
 {
-	vm_size_t bank_size;
-	vm_offset_t pa, va;
+	vm_offset_t va;
+	vm_paddr_t pa;
 
 	size = round_page(size);
 
-	bank_size = phys_avail[1] - phys_avail[0];
-	while (size > bank_size) {
-		int i;
-		for (i = 0; phys_avail[i+2]; i+= 2) {
-			phys_avail[i] = phys_avail[i+2];
-			phys_avail[i+1] = phys_avail[i+3];
-		}
-		phys_avail[i] = 0;
-		phys_avail[i+1] = 0;
-		if (!phys_avail[0])
-			panic("pmap_steal_memory: out of memory");
-		bank_size = phys_avail[1] - phys_avail[0];
-	}
-
-	pa = phys_avail[0];
-	phys_avail[0] += size;
+	pa = vm_phys_bootstrap_alloc(size, 0);
 
 	va = IA64_PHYS_TO_RR7(pa);
 	bzero((caddr_t) va, size);
@@ -1177,7 +1165,7 @@
  */
 static void
 pmap_set_pte(struct ia64_lpte *pte, vm_offset_t va, vm_offset_t pa,
-    boolean_t wired, boolean_t managed)
+    int page_shift, boolean_t wired, boolean_t managed)
 {
 
 	pte->pte &= PTE_PROT_MASK | PTE_PL_MASK | PTE_AR_MASK | PTE_ED;
@@ -1186,7 +1174,7 @@
 	pte->pte |= (wired) ? PTE_WIRED : 0;
 	pte->pte |= pa & PTE_PPN_MASK;
 
-	pte->itir = PAGE_SHIFT << 2;
+	pte->itir = page_shift << 2;
 
 	pte->tag = ia64_ttag(va);
 }
@@ -1284,7 +1272,8 @@
 		else
 			pmap_enter_vhpt(pte, va);
 		pmap_pte_prot(kernel_pmap, pte, VM_PROT_ALL);
-		pmap_set_pte(pte, va, VM_PAGE_TO_PHYS(m[i]), FALSE, FALSE);
+		pmap_set_pte(pte, va, VM_PAGE_TO_PHYS(m[i]), PAGE_SHIFT, FALSE,
+		    FALSE);
 		va += PAGE_SIZE;
 	}
 }
@@ -1325,7 +1314,7 @@
 	else
 		pmap_enter_vhpt(pte, va);
 	pmap_pte_prot(kernel_pmap, pte, VM_PROT_ALL);
-	pmap_set_pte(pte, va, pa, FALSE, FALSE);
+	pmap_set_pte(pte, va, pa, PAGE_SHIFT, FALSE, FALSE);
 }
 
 /*
@@ -1552,8 +1541,8 @@
  *	insert this page into the given map NOW.
  */
 void
-pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
-    boolean_t wired)
+pmap_enter(pmap_t pmap, vm_offset_t va, vm_prot_t fault_type, vm_page_t m,
+    vm_prot_t prot, boolean_t wired)
 {
 	pmap_t oldpmap;
 	vm_offset_t pa;
@@ -1654,7 +1643,7 @@
 	 * adds the pte to the VHPT if necessary.
 	 */
 	pmap_pte_prot(pmap, pte, prot);
-	pmap_set_pte(pte, va, pa, wired, managed);
+	pmap_set_pte(pte, va, pa, PAGE_SHIFT, wired, managed);
 
 	if ((prot & VM_PROT_WRITE) != 0)
 		vm_page_flag_set(m, PG_WRITEABLE);
@@ -1663,6 +1652,55 @@
 	PMAP_UNLOCK(pmap);
 }
 
+#define	NBPDR	SP_SIZE(0)
+#define	PDRMASK	(NBPDR - 1)
+
+SYSCTL_NODE(_vm, OID_AUTO, pmap, CTLFLAG_RD, 0, "VM/pmap parameters");
+
+SYSCTL_NODE(_vm_pmap, OID_AUTO, pde, CTLFLAG_RD, 0, "");
+
+static u_long pmap_pde_mappings;
+SYSCTL_ULONG(_vm_pmap_pde, OID_AUTO, mappings, CTLFLAG_RD,
+    &pmap_pde_mappings, 0, "pde mappings");
+
+static boolean_t
+pmap_enter_pde(pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot)
+{
+	struct ia64_lpte *pte;
+	vm_page_t m_end;
+	boolean_t managed;
+
+	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
+	PMAP_LOCK_ASSERT(pmap, MA_OWNED);
+	m_end = &m[SP_MAGN(m->reserv->level)];
+	while (m < m_end) {
+		if ((pte = pmap_find_pte(va)) == NULL)
+			return (FALSE);
+		if (!pmap_present(pte)) {
+			if ((m->flags & (PG_FICTITIOUS | PG_UNMANAGED)) == 0) {
+				if (!pmap_try_insert_pv_entry(pmap, va, m)) {
+					pmap_free_pte(pte, va);
+					return (FALSE);
+				}
+				managed = TRUE;
+			} else
+				managed = FALSE;
+			pmap->pm_stats.resident_count++;
+			pmap_enter_vhpt(pte, va);
+			pmap_pte_prot(pmap, pte,
+			    prot & (VM_PROT_READ | VM_PROT_EXECUTE));
+			pmap_set_pte(pte, va, VM_PAGE_TO_PHYS(m), PAGE_SHIFT +
+			    SP_SMALL_SHIFT, FALSE, managed);
+		}
+		va += PAGE_SIZE;
+		m++;
+	}
+	pmap_pde_mappings++;
+	CTR2(KTR_PMAP, "pmap_enter_pde: success for va %#lx"
+	    " in pmap %p", va, pmap);
+	return (TRUE);
+}
+
 /*
  * Maps a sequence of resident pages belonging to the same object.
  * The sequence begins with the given page m_start.  This page is
@@ -1680,6 +1718,7 @@
     vm_page_t m_start, vm_prot_t prot)
 {
 	pmap_t oldpmap;
+	vm_offset_t va;
 	vm_page_t m;
 	vm_pindex_t diff, psize;
 
@@ -1689,6 +1728,13 @@
 	PMAP_LOCK(pmap);
 	oldpmap = pmap_switch(pmap);
 	while (m != NULL && (diff = m->pindex - m_start->pindex) < psize) {
+		va = start + ptoa(diff);
+		if ((va & PDRMASK) == 0 && va + NBPDR <= end &&
+		    m->reserv != NULL && m->reserv->first_page == m &&
+		    m->reserv->refcnt == SP_MAGN(m->reserv->level) &&
+		    pmap_enter_pde(pmap, va, m, prot))
+			m = &m[SP_MAGN(m->reserv->level) - 1];
+		else
 		pmap_enter_quick_locked(pmap, start + ptoa(diff), m, prot);
 		m = TAILQ_NEXT(m, listq);
 	}
@@ -1751,7 +1797,8 @@
 		pmap_enter_vhpt(pte, va);
 		pmap_pte_prot(pmap, pte,
 		    prot & (VM_PROT_READ | VM_PROT_EXECUTE));
-		pmap_set_pte(pte, va, VM_PAGE_TO_PHYS(m), FALSE, managed);
+		pmap_set_pte(pte, va, VM_PAGE_TO_PHYS(m), PAGE_SHIFT, FALSE,
+		    managed);
 	}
 }
 
---  ia64/include/param.h.orig
+++  ia64/include/param.h
@@ -107,6 +107,27 @@
 #define PAGE_MASK	(PAGE_SIZE-1)
 #define NPTEPG		(PAGE_SIZE/(sizeof (pt_entry_t)))
 
+/*
+ * SP_LEVELS is the number of superpage sizes.
+ */
+#ifndef	SP_LEVELS
+#define	SP_LEVELS	1
+#endif
+
+/*
+ * SP_SMALL_SHIFT is LOG2(NBPDR / PAGE_SIZE).
+ */
+#ifndef	SP_SMALL_SHIFT
+#define	SP_SMALL_SHIFT	9
+#endif
+
+/*
+ * If there is only one superpage size, then SP_FACTOR_SHIFT is zero.
+ */
+#ifndef	SP_FACTOR_SHIFT
+#define	SP_FACTOR_SHIFT	0
+#endif
+
 #ifndef	KSTACK_PAGES
 #define	KSTACK_PAGES	4		/* pages of kernel stack */
 #endif
---  ia64/include/vmparam.h.orig
+++  ia64/include/vmparam.h
@@ -130,14 +130,21 @@
 #define	VM_NFREEPOOL		2
 #define	VM_FREEPOOL_DEFAULT	0
 #define	VM_FREEPOOL_DIRECT	1
+#define	VM_FREEPOOL_RESERV	0
 
 /*
  * Create one free page list.
  */
-#define	VM_NFREELIST		1
+#define	VM_NFREELIST		2
 #define	VM_FREELIST_DEFAULT	0
+#define	VM_FREELIST_HIGHMEM	1
 
 /*
+ * VM_HIGHMEM_ADDRESS is the physical address at which HIGHMEM starts.
+ */
+#define	VM_HIGHMEM_ADDRESS	4294967296UL
+
+/*
  * An allocation size of 256MB is supported in order to optimize the
  * use of the identity mappings in region 7 by UMA.
  */
@@ -199,4 +206,8 @@
 #define	VM_INITIAL_PAGEIN	16
 #endif
 
+#ifndef	VM_IMAGE_BASE
+#define	VM_IMAGE_BASE		0x2000000000000000
+#endif
+
 #endif	/* !_MACHINE_VMPARAM_H */
---  kern/kern_exec.c.orig
+++  kern/kern_exec.c
@@ -818,6 +818,10 @@
 	if (object == NULL)
 		return (EACCES);
 	VM_OBJECT_LOCK(object);
+	if ((object->flags & OBJ_SUPERPAGES) == 0) {
+		object->flags |= OBJ_SUPERPAGES;
+		object->pg_color = (u_short)atop(VM_IMAGE_BASE);
+	}
 	ma[0] = vm_page_grab(object, 0, VM_ALLOC_NORMAL | VM_ALLOC_RETRY);
 	if ((ma[0]->valid & VM_PAGE_BITS_ALL) != VM_PAGE_BITS_ALL) {
 		initial_pagein = VM_INITIAL_PAGEIN;
---  powerpc/powerpc/mmu_if.m.orig
+++  powerpc/powerpc/mmu_if.m
@@ -206,6 +206,7 @@
 	mmu_t		_mmu;
 	pmap_t		_pmap;
 	vm_offset_t	_va;
+	vm_prot_t	_fault_type;
 	vm_page_t	_p;
 	vm_prot_t	_prot;
 	boolean_t	_wired;
---  powerpc/powerpc/mmu_oea.c.orig
+++  powerpc/powerpc/mmu_oea.c
@@ -311,7 +311,8 @@
 void moea_clear_modify(mmu_t, vm_page_t);
 void moea_clear_reference(mmu_t, vm_page_t);
 void moea_copy_page(mmu_t, vm_page_t, vm_page_t);
-void moea_enter(mmu_t, pmap_t, vm_offset_t, vm_page_t, vm_prot_t, boolean_t);
+void moea_enter(mmu_t, pmap_t, vm_offset_t, vm_prot_t, vm_page_t, vm_prot_t,
+    boolean_t);
 void moea_enter_object(mmu_t, pmap_t, vm_offset_t, vm_offset_t, vm_page_t,
     vm_prot_t);
 void moea_enter_quick(mmu_t, pmap_t, vm_offset_t, vm_page_t, vm_prot_t);
@@ -1056,8 +1057,8 @@
  * will be wired down.
  */
 void
-moea_enter(mmu_t mmu, pmap_t pmap, vm_offset_t va, vm_page_t m, vm_prot_t prot,
-	   boolean_t wired)
+moea_enter(mmu_t mmu, pmap_t pmap, vm_offset_t va, vm_prot_t fault_type,
+    vm_page_t m, vm_prot_t prot, boolean_t wired)
 {
 
 	vm_page_lock_queues();
---  powerpc/powerpc/pmap_dispatch.c.orig
+++  powerpc/powerpc/pmap_dispatch.c
@@ -107,10 +107,10 @@
 }
 
 void
-pmap_enter(pmap_t pmap, vm_offset_t va, vm_page_t p, vm_prot_t prot,
-    boolean_t wired)
+pmap_enter(pmap_t pmap, vm_offset_t va, vm_prot_t fault_type, vm_page_t p,
+    vm_prot_t prot, boolean_t wired)
 {
-	MMU_ENTER(mmu_obj, pmap, va, p, prot, wired);
+	MMU_ENTER(mmu_obj, pmap, va, fault_type, p, prot, wired);
 }
 
 void
---  rpc/rpcclnt.c.orig
+++  rpc/rpcclnt.c
@@ -1,4 +1,4 @@
-/* $FreeBSD: src/sys/rpc/rpcclnt.c,v 1.19 2007/06/16 05:42:26 mjacob Exp $ */
+/* $FreeBSD: src/sys/rpc/rpcclnt.c,v 1.18 2007/03/25 21:44:24 rwatson Exp $ */
 /* $Id: rpcclnt.c,v 1.9 2003/11/05 14:59:03 rees Exp $ */
 
 /*-
@@ -1180,18 +1180,6 @@
 
 	m = rpcclnt_buildheader(rpc, procnum, mrest, mrest_len, &xid, &mheadend,
 	    cred);
-	/*
-	 * This can happen if the auth_type is neither UNIX or NULL
-	 */
-	if (m == NULL) {
-#ifdef __OpenBSD__
-		pool_put(&rpctask_pool, task);
-#else
-		FREE(task, M_RPC);
-#endif
-		error = EPROTONOSUPPORT;
-		goto rpcmout;
-	}
 
 	/*
 	 * For stream protocols, insert a Sun RPC Record Mark.
@@ -1879,7 +1867,6 @@
 	*tl++ = txdr_unsigned(procid);
 
 	if ((error = rpcauth_buildheader(rc->rc_auth, cred, &mb, &bpos))) {
-		m_freem(mreq);
 		RPCDEBUG("rpcauth_buildheader failed %d", error);
 		return NULL;
 	}
